#ifndef         _COMMDEF_H_
#define         _COMMDEF_H_

#include <linux/ioctl.h>

/****************************************************************************/
/*      Typedef  Definitions                                                */
/****************************************************************************/
#include "type_def.h"

//#define   MAX_PCI_CARDS 	12
#define   MAX_PCI_CARDS 	1
#define   SIGEVENT1		63
#define   SIGEVENT2		62
#define   SIGEVENT3		61
#define   SIGEVENT4		60
#define   SIGEVENT5  	59
#define   SIGEVENT6		58
#define   SIGEVENT7		57
#define   SIGEVENT8		56
#define   SIGEVENT9		55
#define   SIGEVENT10	54
#define   SIGEVENT11	53
#define   SIGEVENT12	52
#define   SIGEVENT13	51
#define   SIGEVENT14	50
#define   SIGEVENT15	49
#define   SIGEVENT16	48

#define     TRUE                1
#define     FALSE               0

#define     HIGH                1
#define     LOW                 0

typedef struct {
	void* pSh_Mem;
	U32 RetValue[15];	
} RET_INFO,*PRET_INFO;

typedef struct _Data
{
    U32  Size;
    U32  NextP;
    I32  Data[1024];
} DATA,*PDATA;

typedef struct _Share_Memory
{
  DATA D[2];
  U32 Flag1;
  U32 Flag2;
} SH_MEM, *PSH_MEM;

/****************************************************************************/
/*      PCL_5022 Register Structure Type Define                             */
/****************************************************************************/

typedef struct
{
  U16 offset;	
  U16 ret_val;
  U16 out_val;	
} REG_RW;

typedef struct
{
  U16 val_l;
  U16 val_h;	
} FIFO_W;

typedef struct
{
  U16 offset;	
  U16 cmd;
  U16 ret_val_l;
  U16 ret_val_h;
  U16 out_val_l;	
  U16 out_val_h;	
} REG_RW3;

typedef struct
{
  U16 lcrBase;
  U16 baseAddr;
  U16 irqNo;
} DEV_INIT;

typedef struct
{
  U16 CH0;
  U16 CH1;
  U16 CH0_CTRL;
  U16 CH1_CTRL;
} INT_CTRL;

typedef struct
{
  U16 AXIS;
  U32 EVENT;
  U32 ERROR;
} INT_STATUS;


//#define MAGIC_NUM 'S'
//#define IOCTL_8164_GET_PLX_USR _IOR(MAGIC_NUM, 1, U16)
//#define IOCTL_8164_GET_PLD_VER _IOR(MAGIC_NUM, 2, U16)
//#define IOCTL_8164_SET_PLX_USR3 _IOW(MAGIC_NUM, 3, I16)
//#define IOCTL_8164_GET_PLX_USR2 _IOR(MAGIC_NUM, 4, U16)
//#define IOCTL_8164_PLD_CTRL _IOW(MAGIC_NUM, 5, U16)
//#define IOCTL_8164_FIFO_RST _IOW(MAGIC_NUM, 6, U16)
//#define IOCTL_8164_INT_OFF _IO(MAGIC_NUM, 7)
//#define IOCTL_8164_REG_READ3 _IOWR(MAGIC_NUM, 8, REG_RW3)
//#define IOCTL_8164_REG_WRITE3 _IOWR(MAGIC_NUM, 9, REG_RW3)
//#define IOCTL_8164_REG_READ _IOWR(MAGIC_NUM, 10, REG_RW)
//#define IOCTL_8164_REG_WRITE _IOWR(MAGIC_NUM, 11, REG_RW)
//#define IOCTL_8164_SW_RESET _IO(MAGIC_NUM, 12)
//#define IOCTL_8164_FIFO_WRITE _IOW(MAGIC_NUM, 13, FIFO_W)
//#define IOCTL_8164_SIGNAL_SET _IOW(MAGIC_NUM, 14, U16)
//#define IOCTL_8164_INT_CTRL _IOW(MAGIC_NUM, 15, INT_CTRL)
//#define IOCTL_8164_INT_STATUS_GET _IOWR(MAGIC_NUM, 16, INT_STATUS)
//#define IOCTL_8164_INIT_DEV _IOWR(MAGIC_NUM, 17, DEV_INIT)
//#define IOCTL_8164_FIFO_READ _IOR(MAGIC_NUM, 18, FIFO_W)
//#define IOCTL_8164_DRV_VERSION _IOR(MAGIC_NUM, 19, U16)
//#define IOCTL_8164_HARD_VERSION _IOR(MAGIC_NUM, 20, U16)
//#define IOCTL_8164_DO_WRITE _IOW(MAGIC_NUM, 21, U16)
//#define IOCTL_8164_DI_READ _IOR(MAGIC_NUM, 22, U16)
//#define IOCTL_8164_GET_ADDRESS _IOR(MAGIC_NUM, 23, U16)
//#define IOCTL_8164_GET_IRQ _IOR(MAGIC_NUM, 24, U16)
//#define IOCTL_8164_MPC_GET_INT_FACTOR _IOR(MAGIC_NUM, 25, U16)
//#define IOCTL_8164_MPC_SET_INT_FACTOR _IOR(MAGIC_NUM, 26, U16)

#define MAGIC_NUM 'T'

#define DAS_IOC_GET_GPI \
    	_IOC(_IOC_READ|_IOC_WRITE, MAGIC_NUM, 5, sizeof(__u32))
#define DAS_IOC_SET_GPO \
    	_IOC(_IOC_READ|_IOC_WRITE, MAGIC_NUM, 6, sizeof(__u32))
#define DAS_IOC_GET_GPO \
    	_IOC(_IOC_READ|_IOC_WRITE, MAGIC_NUM, 7, sizeof(__u32))


#endif


